!include "MUI.nsh"

Name "Trajeto"

OutFile "Trajeto-0.2.exe"

SetCompressor /SOLID lzma

InstallDir "$PROGRAMFILES\Trajeto"

InstallDirRegKey HKLM "Software\NSIS_Trajeto" "Install_Dir"

ShowInstDetails show
ShowUninstDetails show

!define MUI_ABORTWARNING

!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\config.txt"
!define MUI_FINISHPAGE_SHOWREADME_TEXT "Edit configuration file"
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_UNCONFIRMPAGE_TEXT_TOP "Trajeto will be uninstalled from the following folder. Please note that the directories containing raw GPS logs and Google Earth tracks will not be deleted. Remove them manually if you don't need them."

!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
  
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

!insertmacro MUI_LANGUAGE "English"

Section ""

  SetOutPath $INSTDIR
  
  File "dist\*.*"
  CreateDirectory "$INSTDIR\logs"
  CreateDirectory "$INSTDIR\tracks"

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\NSIS_Trajeto "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Trajeto" "DisplayName" "Trajeto"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Trajeto" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Trajeto" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Trajeto" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

  CreateDirectory "$SMPROGRAMS\Trajeto"
  CreateShortCut "$SMPROGRAMS\Trajeto\Trajeto.lnk" "$INSTDIR\trajeto.exe" "" "$INSTDIR\trajeto.exe" 0
  CreateShortCut "$SMPROGRAMS\Trajeto\Raw GPS logs.lnk" "$INSTDIR\logs" "" "$INSTDIR\logs" 0
  CreateShortCut "$SMPROGRAMS\Trajeto\Google Earth tracks.lnk" "$INSTDIR\tracks" "" "$INSTDIR\tracks" 0
  CreateShortCut "$SMPROGRAMS\Trajeto\Configuration file.lnk" "$INSTDIR\config.txt" "" "$INSTDIR\config.txt" 0
  CreateShortCut "$SMPROGRAMS\Trajeto\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\Trajeto\Website.lnk" "$INSTDIR\website.url" "" "$INSTDIR\website.url" 0

  ; CreateShortCut "$DESKTOP\Trajeto.lnk" "$INSTDIR\trajeto.exe"
  
SectionEnd


Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Trajeto"
  DeleteRegKey HKLM SOFTWARE\NSIS_Trajeto

  ; Remove files and uninstaller
  Delete "$INSTDIR\*.*"

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\Trajeto\*.*"

  ; Delete "$DESKTOP\Trajeto.lnk"

  ; Remove directories used
  RMDir "$SMPROGRAMS\Trajeto"
  ; RMDir "$INSTDIR"

SectionEnd
